#include "mainwindow.h"
#include <QApplication>
#include <QDebug>

#include <KWayland/Client/connection_thread.h>
#include <KWayland/Client/event_queue.h>
#include <KWayland/Client/plasmashell.h>

#include <KWayland/Client/surface.h>
#include <KWayland/Client/kwaylandclient_export.h>
#include <KWayland/Client/registry.h>
#include <KWayland/Client/connection_thread.h>
#include <KWayland/Client/plasmawindowmanagement.h>
#include <KWayland/Client/plasmashell.h>
#include <KWayland/Client/plasmawindowmodel.h>
#include <KWayland/Server/display.h>
#include <KWayland/Server/plasmawindowmanagement_interface.h>
int main(int argc, char *argv[])
{
    QApplication app(argc, argv);
    MainWindow w;
    w.show();
    using namespace KWayland::Client;

    ConnectionThread *connection = ConnectionThread::fromApplication(&app);
    if (!connection)
    {
        qDebug() << "no connection | x11?";
        //return; //else it crashes
    }
    Registry *registry = new Registry(&app);

    registry->create(connection);
    registry->setup();
    connection->roundtrip();

    PlasmaWindowManagement *m_pw = nullptr;
    m_pw = registry->createPlasmaWindowManagement(registry->interface(Registry::Interface::PlasmaWindowManagement).name,
                                                  registry->interface(Registry::Interface::PlasmaWindowManagement).version,
                                                  &app);
    const auto interface = registry->interface(Registry::Interface::PlasmaShell);
    KWayland::Client::PlasmaShell *m_plasmaShell = registry->createPlasmaShell(interface.name, interface.version, &app);

    Surface *surface = Surface::fromQtWinId(qApp->allWindows().first()->winId());

    KWayland::Client::PlasmaShellSurface *m_plasmaShellSurface = m_plasmaShell->createSurface(surface, &app);
    m_plasmaShellSurface->setSkipTaskbar(true);
    m_plasmaShellSurface->setSkipSwitcher(true);
    m_plasmaShellSurface->setRole(PlasmaShellSurface::Role::Panel);
    m_plasmaShellSurface->setPanelTakesFocus(false);

    m_plasmaShellSurface->setPanelBehavior(KWayland::Client::PlasmaShellSurface::PanelBehavior::AlwaysVisible);
    //1440 displayHeight
    //2160 displaywidth
    //WORKSFOR_LEFT height and width changed
//    m_plasmaShellSurface->setPosition(QPoint(0,0));
//    qApp->allWindows().first()->setX(0);
//    qApp->allWindows().first()->setY(0);
//    qApp->allWindows().first()->setWidth(100);
//    qApp->allWindows().first()->setHeight(2160);

    //WORKSFOR_TOP
//    m_plasmaShellSurface->setPosition(QPoint(0,0));
//    qApp->allWindows().first()->setX(0);
//    qApp->allWindows().first()->setY(0);
//    qApp->allWindows().first()->setWidth(2160);
//    qApp->allWindows().first()->setHeight(100);
    //DOESNTWORK_FOR_BOTTOM whole screen become strut and no window
    //can be placed on that screen anymore
    qApp->allWindows().first()->setX(0);
    qApp->allWindows().first()->setY(1340);
    qApp->allWindows().first()->setWidth(2160);
    qApp->allWindows().first()->setHeight(100);
    m_plasmaShellSurface->setPosition(QPoint(0,1340));

    return app.exec();
}
